//---------------------------------------------------------------------------

#include <clx.h>
#pragma hdrstop

#include "FormMain.h"
#include <vector>
#include <list>
#include "MAcorde.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.xfm"

using namespace std;

double calculaCustoSimilaridade(Acorde *filho, Acorde *pai);

TFormPrincipal *FormPrincipal;
//---------------------------------------------------------------------------
__fastcall TFormPrincipal::TFormPrincipal(TComponent* Owner)
        : TForm(Owner), base("acordes.txt")
{
}
//---------------------------------------------------------------------------

void __fastcall TFormPrincipal::btnFecharClick(TObject *Sender)
{
   this->Close();
}
//---------------------------------------------------------------------------

struct Elemento {
   Elemento() : pai(0), peso(0), acorde(0) {}
   Elemento(Acorde *acorde, double peso)
      : acorde(acorde), peso(peso), pai(0) {}
   Elemento(const Elemento& elemento) {
      *this = elemento;
   }
   Elemento *pai;
   Acorde *acorde;
   double peso;
   Elemento& operator = (const Elemento& el) {
      this->acorde = el.acorde;
      this->peso = el.peso;
      this->pai = el.pai;
      return *this;
   }
};

void __fastcall TFormPrincipal::btnGerarClick(TObject *Sender)
{
   /**
    * Matriz esparsa para armazenar
    * os numeros variaveis de acordes
    */
   vector< vector<Elemento> > matriz;
   /**
    * inicializacao da matriz
    */
   for(int i=0;i<this->memoSeqAcordes->Lines->Count;i++) {
      if(this->memoSeqAcordes->Lines->Strings[i].Trim().IsEmpty()) {
         continue;
      }
      /*pega os acordes da base referentes a entrada atual*/
      list<Acorde*>& lista = this->base.getAcordes(
         this->memoSeqAcordes->Lines->Strings[i].c_str());
      /*cria uma linha na matriz*/
      matriz.push_back(vector<Elemento>());

      /*percorre a lista de acordes*/
      list<Acorde*>::iterator iter = lista.begin();
      while(iter != lista.end()) {
         /*insere um elemento*/
         matriz[i].push_back(Elemento(*iter, 0.0));
         //this->memoAcordesGerados->Lines->Append(((*iter)->toString() + "\n").c_str());
         iter++;
      }
   }

   /*inicio do algoritmo*/
   /**
        (k)
         |
         C C C C
        (j)
         |
   (i)-> D D D
         F F F F F
         A A
    */

   int indiceMenorLinha;
   for(unsigned i=1;i<matriz.size();i++) {

      double menorCustoLinha = 9999999;

      for(unsigned j=0;j<matriz[i].size();j++) {
         double menorCusto = 9999999;
         Elemento *pai;

         for(unsigned k=0;k<matriz[i-1].size();k++) {
            double custoSim = calculaCustoSimilaridade(matriz[i][j].acorde,
                                 matriz[i-1][k].acorde);
            double custo = (custoSim *
               (this->trackSimilaridade->Position/this->trackSimilaridade->Max))+
               (matriz[i][j].acorde->getFacilidade() *
               (this->trackFacilidade->Position/this->trackFacilidade->Max)) +
               (matriz[i][j].acorde->getFlexibilidade() *
               (this->trackFacilidade->Position/this->trackFlexibilidade->Max))+
               (matriz[i][j].acorde->getFrequenciaUso() *
               (this->trackFreqUso->Position/this->trackFreqUso->Max))+
               (matriz[i][j].acorde->getSonoridade() *
               (this->trackSonoridade->Position/this->trackSonoridade->Max));
            /*Adicinar os pesos e outros fatores!*/
            if(custo < menorCusto) {
               menorCusto = custoSim;
               pai = &matriz[i-1][k];
            }
         }

         if(menorCusto < menorCustoLinha) {
            menorCustoLinha = menorCusto;
            indiceMenorLinha = j;
         }
         matriz[i][j].pai = pai;
         matriz[i][j].peso = menorCusto + pai->peso;
      }
   }
   /*Monta a lista de Acordes pra imprimir na ordem certa*/
   list<Acorde*> listaFinal;
   Elemento* el = &matriz[matriz.size()-1][indiceMenorLinha];
   while(el->pai) {
      listaFinal.push_front(el->acorde);
      el = el->pai;
   }
   listaFinal.push_front(el->acorde);

   /*imprime no memo*/
   list<Acorde*>::iterator itr = listaFinal.begin();
   while(itr != listaFinal.end()) {
      this->memoAcordesGerados->Lines->Append(((*itr)->toString() + "\n").c_str());
      itr++;
   }
}

double calculaCustoSimilaridade(Acorde *filho, Acorde *pai) {
   double custoRetorno = 0;
   int i;
   int *posFilho, *posPai, *fingFilho, *fingPai;

   posFilho = new int[6];
   posPai = new int[6];
   fingFilho = new int[6];
   fingPai = new int[6];

    for(i = 0; i < 6; i++) {
      posFilho[i] = filho->getCorda(i).casa;
      posPai[i] = pai->getCorda(i).casa;
      fingFilho[i] = filho->getCorda(i).dedoMaoEsq;
      fingPai[i] = pai->getCorda(i).dedoMaoEsq;
    }

  for(i = 0; i < 6; i++) {
    // avalia o fingering do acorde
    if(fingFilho[i] != fingPai[i]) {
  //      custoRetorno += 2 + abs(fingFilho[i] - fingPai[i]);
        if(posFilho[i] != posPai[i]) {
  //            custoRetorno += 1;
          if((posPai[i] != 0) && (posFilho[i] != 0)) {
            custoRetorno += 3 + abs(posFilho[i] - posPai[i]);
          } else {
  //            custoRetorno += 1;
          }
        } else {
          custoRetorno += 3 + abs(fingFilho[i] - fingPai[i]);
        }
    }
    else {
    // avalia a posicao do acorde.
      if(posFilho[i] != posPai[i]) {
    //      custoRetorno += 1;
       custoRetorno += 1 + abs(posFilho[i] - posPai[i]);
   //    }
      }
   }
  }
  return custoRetorno;
}
//---------------------------------------------------------------------------

