//---------------------------------------------------------------------------

#ifndef MAcordeH
#define MAcordeH
#include <string>

using namespace std;

class Acorde {
   public:
      struct Corda {
         Corda(){}
         Corda(int casa, int dedoMaoDir, int dedoMaoEsq)
            : casa(casa), dedoMaoDir(dedoMaoDir),
              dedoMaoEsq(dedoMaoEsq){}
         Corda(const Corda& corda) {
            *this = corda;
         }
         
         int casa;
         int dedoMaoDir;
         int dedoMaoEsq;

         Corda& operator = (const Corda& corda) {
            this->casa = corda.casa;
            this->dedoMaoDir = corda.dedoMaoDir;
            this->dedoMaoEsq = corda.dedoMaoEsq;
            return *this;
         }
      };

      Acorde();
      Acorde(const Acorde& acorde);
      virtual ~Acorde();

      void setCorda(unsigned index, const Corda& corda);
      Corda getCorda(unsigned index) const;
      void setNome(string nome);
      string getNome() const;
      int getFacilidade() const;
      void setFacilidade(int facilidade);
      int getFlexibilidade() const;
      void setFlexibilidade(int flexibilidade);
      int getFrequenciaUso() const;
      void setFrequenciaUso(int frequenciaUso);
      int getSonoridade() const;
      void setSonoridade(int sonoridade);
      string toString() const;
      Acorde& operator = (const Acorde& acorde);


   private:
      Corda cordas[6];
      string nome;
      int facilidade;
      int flexibilidade;
      int frequenciaUso;
      int sonoridade;
};
//---------------------------------------------------------------------------
#endif
